#import "BuiltInDeviceController.h"
#import <InstantMessage/IMAVManager.h>
#import <InstantMessage/IMService.h>


@implementation BuiltInDeviceController
- (void)_stateChanged:(NSNotification *)aNotification {
    // Read the state.
    IMAVManagerState state = [[IMAVManager sharedAVManager] state];
	NSLog(@"%ld state",(long)state);
	
    // Update the play button based on the state.
	[iChatButton setState:(state >= IMAVPending) ? NSOffState : NSOnState];
    [iChatButton setEnabled:(state >= IMAVPending || state == IMAVStopped)];
}

- (void)awakeFromNib {
	toolbar = [[NSToolbar alloc] initWithIdentifier:@"DeviceToolbar"];
	
	[toolbar setAllowsUserCustomization:YES];
	[toolbar setAutosavesConfiguration:YES];
	[toolbar setDisplayMode:NSToolbarDisplayModeIconOnly];
	
	[toolbar setDelegate:self];
	[[self window] setToolbar:toolbar];
	
    [self _stateChanged:nil];
    [[IMService notificationCenter] addObserver:self selector:@selector(_stateChanged:)
                                           name:IMAVManagerStateChangedNotification object:nil];
	[[IMAVManager sharedAVManager] setVideoDataSource:aView];	
}

- (NSToolbarItem *)toolbar:(NSToolbar *)toolbar itemForItemIdentifier:(NSString *)ident willBeInsertedIntoToolbar:(BOOL)flag {
	NSToolbarItem *item = [[NSToolbarItem alloc] initWithItemIdentifier:ident];
	if([ident isEqual:@"iChat"]) {
		[item setLabel:@"iChat Theater"];
		[item setPaletteLabel:@"iChat Theater"];
		[item setToolTip:@"Connect/Disconnect iChat Theater"];
		[item setView:iChatView];
	} else if([ident isEqual:@"Drawing"]) {
		
	}
	return item;
}

- (NSArray*)toolbarAllowedItemIdentifiers:(NSToolbar*)toolbar {
	return [NSArray arrayWithObjects:@"iChat",nil];
}

- (NSArray *)toolbarDefaultItemIdentifiers:(NSToolbar *)toolbar {
	return [NSArray arrayWithObjects:@"iChat",nil];	
}

- (BOOL)validateToolbarItem:(NSToolbarItem*)item {
	return YES;
}



- (void)setDeviceDescription:(void*)aDesc {
	[aView setDeviceDescription:aDesc];
}

- (NSString*)windowTitleForDocumentDisplayName:(NSString*)displayName {
	return @"Quartz Device";
}

- (IBAction)toggleTheaterConnection:(id)sender {
    IMAVManager *avManager = [IMAVManager sharedAVManager];
    if ([avManager state] == IMAVStopped) {
		[aView activateIMLink:self];
        [avManager start];
    } else {
		[aView deactivateIMLink:self];
        [avManager stop];
    }	
}

- (IBAction)toggleBrowser:(id)sender {
}

- (IBAction)toggleSidebar:(id)sender {
}

- (IBAction)drawingToolSelected:(id)sender {
}

@end
